//This code is writed by Nikos Mourgis. (nikosmourgis@gmail.com)
//The following code is writed with the convenience in mind and not
//for efficiency. The code may contains bugs that was unnoticed while testing.
//use it freely at your convinience but please do not sell this code , and please
//do not remove this header. Last Update : 03/01/2018 

#ifndef UNICODE
#define UNICODE
#endif
#ifndef WINDOWS
#define WINDOWS
#include<windows.h>
#endif

#ifndef WINPROC
#define WINPROC
#include "WinProc.h"
#endif


//basic string operations. NOTE that the code s = s + s; will not work , use this instead : s+s;


class wString
{

private:
    WCHAR * str;
    char * astr;
    ULONG Length;
    void Copy(const WCHAR *S);
    void Concatenate(const WCHAR *S);
    bool pass;
public:
    int GetLength();
    WCHAR *Str();
    char *Stra();
    void wFree();
    void wFreea();
    bool IsPass();
    void SetPass(bool p);
    wString &wTrimRight();
    wString &wTrimLeft();
    wString &wTrim();
    wString &wReplaceChar(WCHAR oldch, WCHAR newch);
    wString &wRemoveChar(WCHAR remch);
    wString &wUpperCase();
    wString &wCopyToChar(WCHAR *source,WCHAR ch,ULONG &indx);
    wString &wCopyToChar(wString source,WCHAR ch,ULONG &indx);
    wString &Reverse();
    WCHAR operator [](unsigned long Index);
    wString &operator =(const WCHAR *S);
    wString &operator =(wString &S);
    wString &operator =(const char *S);
    wString &operator +(const WCHAR *S);
    wString &operator +(wString &S);
    wString &operator +(const WCHAR c);
    wString &operator +(const char ch);
    bool operator ==(wString &S);
    bool operator ==(char *S);
    bool operator ==(const WCHAR *S);
    bool operator !=(wString &S);
    bool operator !=(char *S);
    bool operator !=(const WCHAR *S);


wString();
wString(const wString &wstr);
~wString();

};

void Smessage(wString mess)
{
    MessageBox(NULL,mess.Str(),L"Message",MB_OK);

}

//code


    wString::wString()
    {
        str=NULL;
        astr=NULL;
        pass=false;
        Length=0;
    };

    wString::wString(const wString &wstrng)
    {
      str=NULL;
      astr=NULL;
      Copy(wstrng.str);

    };

    wString::~wString()
    {
        wFree();
    };


     void wString::Copy(const WCHAR *S)
     {       if ((S!=NULL)&&(S[0]!=0))
             {
             ULONG len=StrLen(S);
         if (len==0) len=1;
             wFree();
             str=new WCHAR[len+1];
             CopyStr(str,S,len+1);
             Length=StrLen(str);
             if (Length<=0)Length++;
             }
             else
             {
               str=NULL;
               Length=0;
             }

     };


     void wString::Concatenate(const WCHAR *S)
     {
         ULONG len=Length+(StrLen(S));
          WCHAR * temp;
          const WCHAR *conc;
          temp=new WCHAR[len+1];
          bool frdel=false;
          if ((str!=NULL)&&(str[0]!=0))
          {
          CopyStr(temp,str,len+1);
          conc=ConCat(temp,S);
          frdel=true;
          }else
          conc=S;
          wFree();
          ULONG sl=StrLen(conc)+1;
          str=new WCHAR[sl];
          CopyStr(str,conc,sl);
          if(frdel==true)delete [] conc;
         Length=StrLen(str);           
         delete [] temp;
          if (Length<=0)Length++;
     };

     void wString::wFree()
     {
          if (str!=NULL)delete [] str;
          if (astr!=NULL)delete [] astr;
          str=NULL;
          astr=NULL;
     }
      void wString::wFreea()
     {
          if (astr!=NULL)delete [] astr;
          astr=NULL;
     }

     int wString::GetLength()
     {
        return Length;
     };

     WCHAR *wString::Str()
     {
        return str;
     }

      char *wString::Stra()
     {
        if (Length==0) astr=NULL;
        else
            {
                if (astr!=NULL) delete [] astr;

                 astr=ConvertUTF8ToAnsi(str); 

            }
        return astr;
     }

    bool wString::IsPass()
    {
        return pass;
    };
    void wString::SetPass(bool p)
    {
       pass=p;
    };

     wString &wString::wTrimRight()
     {
         WCHAR *tmp;
         tmp=TrimRight(str);
         Copy(tmp);
         delete [] tmp;
         return *this;

     }


    wString &wString::wTrimLeft()
    {
         WCHAR *tmp;
         tmp=TrimLeft(str);
         Copy(tmp);
         delete [] tmp;
         return *this;
    }

    wString &wString::wTrim()
    {
         WCHAR *tmp=Trim(str);
         Copy(tmp);
         delete [] tmp;
         return *this;
    }

    wString &wString::wReplaceChar(WCHAR oldch, WCHAR newch)
    {
         WCHAR *tmp;
         tmp=ReplaceChar(str,oldch,newch);
         Copy(tmp);
         delete [] tmp;
         return *this;

    }

    wString &wString::wRemoveChar(WCHAR remch)
    {
         WCHAR *tmp;
         tmp=RemoveChar(str,remch);
         Copy(tmp);
         delete [] tmp;
         return *this;
    }

    wString &wString::wUpperCase()
    {
         WCHAR *tmp;
         tmp=UpperCase(str);
         Copy(tmp);
         delete [] tmp;
         return *this;
    }

    wString &wString::wCopyToChar(WCHAR *source,WCHAR ch,ULONG &indx)
    {
         WCHAR *tmp=CopyStrCh(source,ch,indx);
         Copy(tmp);
         delete [] tmp;
         return *this;
    }

     wString &wString::wCopyToChar(wString source,WCHAR ch,ULONG &indx)
    {
         WCHAR *tmp=CopyStrCh(source.Str(),ch,indx);
         Copy(tmp);
         delete [] tmp;
         return *this;
    }


    wString &wString::Reverse()
    {
           WCHAR * tmp=new WCHAR[Length+1];
            ZeroMemory(tmp,(Length+1)*2);

            ReverseString(str,tmp);

             wFree();
             str=new WCHAR[Length+1];

             ZeroMemory(str,(Length+1)*2);

             CopyStr(str,tmp,Length+1);

             delete [] tmp;

             return *this;

    }

     WCHAR wString::operator [](unsigned long Index)
     {
         if (str!=NULL)
         {
             if (Index<Length)
             return str[Index];
             else
             return 0;
         }
         return 0;

    };


    wString &wString::operator =(const WCHAR *S)
    {
               Copy(S);
               return *this;
    };


  wString &wString::operator =(wString &S)
    {

    if(S==*this) return *this;
            if (S.str==NULL)
            {
              str=NULL;
              return *this;
            };
            if (str!=NULL) wFree();
            ULONG sl=StrLen(S.str)+1;
              str=new WCHAR[sl];
               CopyStr(str,S.str,sl);
               Length=StrLen(str);
               return *this;
    }

    wString &wString::operator =(const char *S)
    {
               WCHAR * tmp=ConvertAnsiToUTF8(S);
               Copy(tmp);
               delete [] tmp;
               return *this;
    };

    wString &wString::operator +(const WCHAR *S)
    {
      Concatenate(S);
      return *this;
    };


    wString &wString::operator +(wString &S)
    {
         if (S.GetLength()>0)
         Concatenate(S.str);
            return *this;
    }

    wString &wString::operator +(const WCHAR c)
    {
            WCHAR * tmp=new WCHAR[Length+2];
            ZeroMemory(tmp,(Length+2)*2);

             if (str!=NULL)
             {

             CopyStr(tmp,str,Length+2);
             Length+=1;
             wFree();
             tmp[Length-1]=c;
             str=new WCHAR[Length+1];

             ZeroMemory(str,(Length+1)*2);

             CopyStr(str,tmp,Length+1);

             } else
                   {
                     str=new WCHAR[2];
                     str[0]=c;
                     str[1]=0;
                     Length=1;
                   };

    delete [] tmp;

    return *this;
    };


     wString &wString::operator +(const char ch)
    {

            char tmp1[2];
            tmp1[0]=ch;
            tmp1[1]=0;
            WCHAR c;
            WCHAR *tmp2;
            tmp2=ConvertAnsiToUTF8(tmp1);
            c=tmp2[0];

            delete [] tmp2;

            WCHAR * tmp=new WCHAR[Length+2];
            ZeroMemory(tmp,(Length+2)*2);

             if (str!=NULL)
             {

             CopyStr(tmp,str,Length+2);
             Length+=1;
             wFree();
             tmp[Length-1]=c;
             str=new WCHAR[Length+1];

             ZeroMemory(str,(Length+1)*2);

             CopyStr(str,tmp,Length+1);

             delete [] tmp;
             } else
                   {
                     str=new WCHAR[2];
                     str[0]=c;
                     str[1]=0;
                     Length=1;
                   };

            return *this;
    }

 bool wString::operator ==(wString &S)
   {   if (S.str==NULL) return false;
       if (wCompareStr(str,S.Str())==0)
       return true;
       else
       return false;
   }

 bool wString::operator ==(const WCHAR *S)
   {
       if (S==NULL) return false;
       if (wCompareStr(str,S)==0)
       return true;
       else
       return false;
   }

   bool wString::operator ==(char *S)
   {
       if (S==NULL) return false;
       WCHAR * tmp=ConvertAnsiToUTF8(S);
       if (wCompareStr(str,tmp)==0)
       {
          delete [] tmp;
          return true;
       }

       else
       {
         delete [] tmp;
         return false;
       }

   }



 bool wString::operator !=(wString &S)
   {
       if (wCompareStr(str,S.Str())!=0)
       return true;
       else
       return false;
   }

 bool wString::operator !=(const WCHAR *S)
   {
       if (wCompareStr(str,S)!=0)
       return true;
       else
       return false;
   }

    bool wString::operator !=(char *S)
   {
       if (S==NULL) return false;
       WCHAR * tmp=ConvertAnsiToUTF8(S);
       if (wCompareStr(str,tmp)!=0)
       {
          delete [] tmp;
          return true;
       }

       else
       {
         delete [] tmp;
         return false;
       }

   }















